<template>
    <div class="row clearfix">
        <div class="col-lg-12 col-md-12">
            <div
                v-if="error"
                class="alert alert-danger alert-dismissible fade show"
                role="alert"
            >
                {{ error }}
                <button
                    type="button"
                    class="close"
                    data-dismiss="alert"
                    aria-label="Close"
                    @click="error = ''"
                >
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <div
                v-if="success"
                class="alert alert-success alert-dismissible fade show"
                role="alert"
            >
                {{ success }}
                <button
                    type="button"
                    class="close"
                    data-dismiss="alert"
                    aria-label="Close"
                    @click="success = ''"
                >
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
        </div>
        <div class="col-lg-6 col-md-12">
            <div class="form-group">
                <input
                    disabled
                    v-model="user.firstname"
                    type="text"
                    class="form-control"
                    :placeholder="fields.firstname"
                />
            </div>
        </div>
        <div class="col-lg-6 col-md-12">
            <div class="form-group">
                <input
                    disabled
                    v-model="user.lastname"
                    type="text"
                    class="form-control"
                    :placeholder="fields.lastname"
                />
            </div>
        </div>
        <div class="col-lg-6 col-md-12">
            <div class="form-group">
                <input
                    disabled
                    v-model="user.email"
                    type="text"
                    class="form-control"
                    :placeholder="fields.email"
                />
            </div>
        </div>
        <div class="col-lg-6 col-md-12">
            <div class="form-group">
                <input
                    type="date"
                    v-model="info.birthdate"
                    class="form-control"
                    :placeholder="fields.email"
                    :max="pasado"
                />
            </div>
        </div>
        <div class="col-lg-4 col-md-12">
            <div class="form-group">
                <input
                    v-model="info.dni"
                    type="text"
                    class="form-control"
                    placeholder="#DNI"
                />
            </div>
        </div>
        <div class="col-lg-4 col-md-12">
            <div class="form-group">
                <input
                    v-model="info.phone"
                    type="text"
                    class="form-control"
                    :placeholder="fields.phone"
                />
            </div>
        </div>
        <div class="col-lg-4 col-md-12">
            <div class="form-group">
                <v-select
                    v-model="gender"
                    class="form-control"
                    label="name"
                    :options="genderSelect"
                ></v-select>
            </div>
        </div>
        <div class="col-lg-12 col-md-12">
            <div class="form-group">
                <vue-google-autocomplete
                    ref="address"
                    id="map"
                    classname="form-control"
                    :placeholder="fields.address"
                    v-on:placechanged="getAddressData"
                    :country="['ve', 'uy']"
                    :enable-geolocation="true"
                    types="geocode"
                >
                </vue-google-autocomplete>
            </div>
        </div>
        <div class="col-lg-4 col-md-12">
            <div class="form-group">
                <input
                    v-model="info.postal_code"
                    type="text"
                    class="form-control"
                    :placeholder="fields.postal_code"
                />
            </div>
        </div>

        <div class="col-lg-4 col-md-12">
            <div class="form-group">
                <input
                    v-model="info.ciudad"
                    disabled
                    type="text"
                    class="form-control"
                    :placeholder="fields.city.title"
                />
            </div>
        </div>
        <div class="col-lg-4 col-md-12">
            <div class="form-group">
                <input
                    v-model="info.country"
                    disabled
                    type="text"
                    class="form-control"
                    :placeholder="fields.country.title"
                />
            </div>
        </div>
        <div class="col-md-12">
            <div class="form-group m-b-10">
                <input
                    v-model="info.address_1"
                    type="text"
                    class="form-control"
                    :placeholder="fields.address_line_1"
                />
            </div>
        </div>
        <div class="col-md-12">
            <div class="form-group m-b-10">
                <input
                    v-model="info.address_2"
                    type="text"
                    class="form-control"
                    :placeholder="fields.address_line_2"
                />
            </div>
        </div>
        <div class="col-md-12">
            <div class="form-group m-b-10">
                <textarea
                    v-model="info.description"
                    rows="4"
                    class="form-control no-resize"
                    :placeholder="fields.description"
                ></textarea>
            </div>
        </div>
        <!-- <div class="col-md-12">
            <div class="checkbox">
                <input id="procheck2" type="checkbox" />
                <label for="procheck2">New task notifications</label>
            </div>
            <div class="checkbox">
                <input id="procheck3" type="checkbox" />
                <label for="procheck3">New friend request notifications</label>
            </div>
        </div> -->
        <div class="col-md-12">
            <button @click.prevent="update()" class="btn btn-primary btn-round">
                Save Changes
            </button>
        </div>
    </div>
</template>

<script>
import VueGoogleAutocomplete from "vue-google-autocomplete";
import "vue-select/dist/vue-select.css";
export default {
    components: { VueGoogleAutocomplete },
    props: ["users", "trans"],
    created() {
        this.today;
        this.get();
    },
    mounted() {
        this.$refs.address.focus();
    },
    data() {
        return {
            pasado: this.today(),
            fields: this.trans.edit_info,
            user: this.users,
            info: {
                user_id: "",
                phone: "",
                gender: "",
                postal_code: "",
                country: "",
                ciudad: "",
                address_1: "",
                address_2: "",
                description: "",
                dni: "",
                birthdate: ""
            },
            address: "",
            country: "",
            state: "",
            error: "",
            success: "",
            gender: [],
            genderSelect: [
                { id: 0, name: this.trans.edit_info.gender.male },
                { id: 1, name: this.trans.edit_info.gender.female },
                { id: 2, name: this.trans.edit_info.gender.no_binary }
            ],
            // there will be a selected item
            selected: null,
            loading: false,
            timeoutId: null,
            noData: false
        };
    },
    methods: {
        today() {
            let hoy = new Date(Date.now());
            let year = hoy.getFullYear();
            let month = hoy.getMonth() + 1;
            if (month < 10) {
                month = "0" + month;
            }
            let day = hoy.getDate();
            if (day < 10) {
                day = "0" + day;
            }
            return year - 18 + "-" + day + "-" + month;
        },
        getAddressData: function(addressData, placeResultData, id) {
            this.address = addressData;
            this.info.postal_code = this.address.postal_code;
            this.info.ciudad = this.address.administrative_area_level_1;
            this.info.country = this.address.country;
            this.info.address_1 = this.address.route;
            console.log(this.address);
        },
        update() {
            let url = "/api/users/information/" + this.user.id;
            this.info.gender = this.gender.id;
            let info = { info: this.info };
            this.user.info = this.info;

            if (new Date(this.info.birthdate) > new Date(this.today())) {
                this.success = "";
                this.error = "The birthdate is invalid";
                return false;
            }
            console.log(this.user);
            axios
                .put(url, this.user)
                .then(res => {
                    this.error = "";
                    this.success = res.data.message;
                })
                .catch(err => {
                    this.error = err.response.data.message;
                    this.success = "";
                });
        },
        get() {
            if (this.user.info) {
                this.info.user_id = this.user.info.user_id;
                this.info.country = this.user.info.country;
                this.country = this.user.info.country;
                this.info.ciudad = this.user.info.ciudad;
                this.state = this.user.info.ciudad;
                this.info.address_1 = this.user.info.address_1;
                this.info.address_2 = this.user.info.address_2;
                this.info.phone = this.user.info.phone;
                this.info.description = this.user.info.description;
                this.info.postal_code = this.user.info.postal_code;
                this.gender.id = this.user.info.gender;
                this.info.dni = this.user.info.dni;
                this.info.birthdate = this.user.info.birthdate;
            }
        }
    }
};
</script>
<style></style>
